summaryrefslogtreecommitdiff
path: root/plugins/git/git.plugin.zsh
diff options
context:
space:
mode:
Diffstat (limited to 'plugins/git/git.plugin.zsh')
-rw-r--r--plugins/git/git.plugin.zsh47
1 files changed, 44 insertions, 3 deletions
diff --git a/plugins/git/git.plugin.zsh b/plugins/git/git.plugin.zsh
index 71a62819b..14ae78d41 100644
--- a/plugins/git/git.plugin.zsh
+++ b/plugins/git/git.plugin.zsh
@@ -1,23 +1,55 @@
# Aliases
alias g='git'
+compdef g=git
alias gst='git status'
+compdef _git gst=git-status
alias gl='git pull'
-alias gup='git fetch && git rebase'
+compdef _git gl=git-pull
+alias gup='git pull --rebase'
+compdef _git gup=git-fetch
alias gp='git push'
-alias gd='git diff | mate'
-alias gdv='git diff -w "$@" | vim -R -'
+compdef _git gp=git-push
+gdv() { git diff -w "$@" | view - }
+compdef _git gdv=git-diff
alias gc='git commit -v'
+compdef _git gc=git-commit
alias gca='git commit -v -a'
+compdef _git gca=git-commit
alias gco='git checkout'
+compdef _git gco=git-checkout
+alias gcm='git checkout master'
alias gb='git branch'
+compdef _git gb=git-branch
alias gba='git branch -a'
+compdef _git gba=git-branch
alias gcount='git shortlog -sn'
+compdef gcount=git
alias gcp='git cherry-pick'
+compdef _git gcp=git-cherry-pick
alias glg='git log --stat --max-count=5'
+compdef _git glg=git-log
+alias glgg='git log --graph --max-count=5'
+compdef _git glgg=git-log
+alias gss='git status -s'
+compdef _git gss=git-status
+alias ga='git add'
+compdef _git ga=git-add
+alias gm='git merge'
+compdef _git gm=git-merge
+alias grh='git reset HEAD'
+alias grhh='git reset HEAD --hard'
+alias gwc='git whatchanged -p --abbrev-commit --pretty=medium'
+
+# Will cd into the top of the current repository
+# or submodule.
+alias grt='cd $(git rev-parse --show-toplevel || echo ".")'
# Git and svn mix
alias git-svn-dcommit-push='git svn dcommit && git push github master:svntrunk'
+compdef git-svn-dcommit-push=git
+alias gsr='git svn rebase'
+alias gsd='git svn dcommit'
#
# Will return the current branch name
# Usage example: git pull origin $(current_branch)
@@ -27,7 +59,16 @@ function current_branch() {
echo ${ref#refs/heads/}
}
+function current_repository() {
+
+ ref=$(git symbolic-ref HEAD 2> /dev/null) || return
+ echo $(git remote -v | cut -d':' -f 2)
+}
+
# these aliases take advantage of the previous function
alias ggpull='git pull origin $(current_branch)'
+compdef ggpull=git
alias ggpush='git push origin $(current_branch)'
+compdef ggpush=git
alias ggpnp='git pull origin $(current_branch) && git push origin $(current_branch)'
+compdef ggpnp=git